module Reelagram
  module Mail
    module Processors
      class ShippingProcessor
        attr_reader :data, :parser
        attr_reader :current_string
        attr_reader :results

        def initialize(data, parser)
          @data    = [data].flatten
          @parser  = parser
        end

        def run
          data.map { |email| process_email(email[:body]) }
        end

        private

        def process_email(email)
          email_data = build_email_hash(parser.run(email))
          parser.reset!
          email_data
        end

        def build_email_hash(email)
          {
            order_id:        email.order_number,
            carrier:         email.carrier,
            tracking_number: email.tracking_number,
            tracking_link:   email.tracking_link
          }
        end
      end
    end
  end
end
